=== debian/changelog ===
yosys (0.7-2) unstable; urgency=medium

  * debian/control:
    - Moved berkeley-abc from Build-Depends-Indep to Build-Depends in order
      to fix dependency problem during test.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 06 Nov 2016 14:40:47 +0000

yosys (0.7-1) unstable; urgency=medium

  * New upstream release
  * Refreshed patches. Some patches applied upstream and deleted.
  * Updated man page for yosys
  * Simplified debian/*.install files
  * debian/patches/03_notruntests.patch deleted
    - Tests can now be run during build since an updated version
      of iverilog is in the archive
  * debian/control:
    - Depend on a newer version of berkeley-abc
    - Build-depend on iverilog >= 10.1

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 06 Nov 2016 11:28:06 +0100
