=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d "`dpkg-parsechangelog --show-field Date`" +"%d %B %Y")


%:
	PREFIX=/usr dh $@ --parallel --with=python3


override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1

override_dh_auto_configure:
	make config-gcc

override_dh_install:
	dh_install --fail-missing

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

override_dh_compress:
	dh_compress --exclude=.pdf

override_dh_auto_build-arch:
	dh_auto_build --parallel -- all

override_dh_auto_build-indep:
	dh_auto_build --parallel -- all manual
