=== debian/tests/control ===
Tests: ice
Depends: @
