=== debian/watch ===
version=3
https://github.com/cliffordwolf/yosys/releases /cliffordwolf/yosys/archive/\w+-(\d\S+)\.tar\.(?:bz2|gz|xz)
