=== debian/changelog ===
yosys (0.8-1) unstable; urgency=medium

  * New upstream release
  * debian/control:
    - New standards version 4.2.1 - no changes
  * debian/copyright:
    - New copyright years
    - Some new copyright holders for certain files
  * debian/patches: Fix patches after importing new version
  * d/patches/0013-Let-dpkg-buildpackage-handle-stripping-of-binaries.patch:
    - Fix issue with empty -dbgsym package
  * debian/rules:
    - Enable hardening
    - Remove redundant '--parallel'
    - Override dh_auto_install and remove executable permission on some files
    - Delete one more file in override_dh_auto_clean
  * debian/yosys.1: Updated man page for new version
  * debian/yosys.install: Install new files
  * debian/yosys.lintian-overrides:
    - Waive a 'spelling error' which is in fact not an error.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Wed, 17 Oct 2018 18:36:13 +0200

yosys (0.7-8) unstable; urgency=medium

  * d/patches/0012-Skip-non-deterministic-test-causing-random-FTBFS-on-.patch:
    - Disable test which fails some times when being built (Closes: #907211)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 04 Sep 2018 20:00:14 +0200

yosys (0.7-7) unstable; urgency=medium

  * debian/patches/0011-Do-not-show-g-build-flags-in-Version-string.patch:
    - Do not quote CXXFLAGS_FOR_YOSYS_CONFIG (fixes build on all)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Wed, 22 Aug 2018 07:23:08 +0200

yosys (0.7-6) unstable; urgency=medium

  * debian/compat: level 11
  * debian/control:
    - debhelper >= 11
    - Standards version 4.2.0 - no changes
  * debian/upstream/metadata: Added upstream metadata
  * d/patches/0011-Do-not-show-g-build-flags-in-Version-string.patch:
    - some build flags for the g++ version being used were "injected" into
      the source files for yosys. Remove them

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 21 Aug 2018 21:37:46 +0200

yosys (0.7-5) unstable; urgency=medium

  * debian/patches/0010-Fix-adding-of-sys.path-in-yosys-smtbmc.patch
    - Fix "ModuleNotFoundError: No module named 'smtio'" (Closes: #904752)
  * debian/tests/smtbc:
    - Added CI test to check that 'yosys-smtbmc' can be started with no
      import errors

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 27 Jul 2018 20:57:41 +0200

yosys (0.7-4) unstable; urgency=medium

  * d/patches/0010-Fix-reproducibility-of-PDF-documents-in-yosys-doc.patch
    - Another attempt of getting full reproducibility of PDF documents
      in yosys-doc

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 14 Jul 2018 23:47:09 +0200

yosys (0.7-3) unstable; urgency=low

  * debian/copyright:
    - Use https protocol in Format field
  * debian/control:
    - Added dh-python as build-dependency (Closes: #896802)
    - Changed VCS URLs to Salsa
    - Mark 'yosys-doc' Multi-Arch: foreign
    - Remove 'Testsuite: autopkgtest' since it is now handled automatically
    - Updated Standards Version to 4.1.5 - requires reproducibility
  * debian/patches:
    - 0007-Disable-pretty-build.patch: New patch to disable pretty build
      (Closes: #847110)
    - 0008-Set-fixed-date-when-calling-pdflatex-for-presentatio.patch
      Improve reproducibility
    - 0009-Some-spelling-errors-fixed.patch: Fixed some spelling errors
      detected by lintian
  * debian/rules:
    - Pass down changelog date to pdflatex
    - Upstream source has moved to https://github.com/YosysHQ/yosys
    - Use /usr/share/dpkg/pkg-info.mk instead of separate calls to
      dpkg-parsechangelog
  * debian/watch:
    - Fix watch URL - now github.com/YosysHQ/yosys/releases

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 12 Jul 2018 17:27:53 +0200
