=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
            Sebastian Kuzminsky <seb@highlab.com>
 Section: electronics
 Priority: optional
-Testsuite: autopkgtest
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 11),
+               dh-python,
                tcl-dev,
                libreadline-dev,
                bison,
@@ -30,9 +30,9 @@
                texlive-bibtex-extra,
                lmodern,
                graphviz
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/yosys.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/yosys.git
+Standards-Version: 4.2.1
+Vcs-Browser: https://salsa.debian.org/science-team/yosys
+Vcs-Git: https://salsa.debian.org/science-team/yosys.git
 Homepage: http://www.clifford.at/yosys
 
 Package: yosys
@@ -71,6 +71,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Suggests: yosys
 Description: Documentation for Yosys
  Yosys is a framework for Verilog RTL synthesis. It currently has extensive
