=== debian/tests/control ===
Tests: ice, smtbc
Depends: @
