=== debian/changelog ===
yosys (0.8+20190328git32bd0f2-1~exp1) experimental; urgency=low

  * New upstream GIT HEAD
  * debian/control:
    - New standards version 4.3.0 - no changes
  * debian/copyright:
    - Added new copyright holders
  * debian/patches: Refreshed patches
  * debian/yosys.install: Install more files

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 31 Mar 2019 00:01:48 +0100
