=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
                texlive-bibtex-extra,
                lmodern,
                graphviz
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/science-team/yosys
 Vcs-Git: https://salsa.debian.org/science-team/yosys.git
 Homepage: http://www.clifford.at/yosys
